-- IBM Confidential
-- OCO Source Materials
-- 5724-I68.
-- (C) Copyright IBM Corp. 2000, 2004 - All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure 
-- restricted by GSA ADP Schedule Contract with IBM Corp. 
-- This file is generated by GenSchema!! DO NOT EDIT!!!
-- This file is generated by GenSchema!! DO NOT EDIT!!!


-- ===================================================================
--
-- Table tdoc_dbl_doc_blob
--
-- Contains the content of a document
-- ===================================================================

drop table tdoc_dbl_doc_blob cascade constraints;
create table tdoc_dbl_doc_blob
( 
    dbl_cmp_id                    number(9, 0),
    dbl_doc_id                    number(9, 0),
    dbl_blob                      blob
) 
tablespace blob_tbl_data;


drop synonym dbl;
create synonym dbl for tdoc_dbl_doc_blob;

drop sequence qdoc_dbl_doc_id;
create sequence qdoc_dbl_doc_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tdoc_dhi_doc_hierarchy
--
-- Contains the path of a document
-- ===================================================================

drop table tdoc_dhi_doc_hierarchy cascade constraints;
create table tdoc_dhi_doc_hierarchy
( 
    dhi_cmp_id                    number(9, 0) not null,
    dhi_doc_id                    number(9, 0),
    dhi_doc_path                  varchar2(1000) not null,
    dhi_doc_real_path             varchar2(1000),
    dhi_object_group_id           number(9, 0),
    dhi_system_doc                varchar2(30),
    constraint dhi_0_uk
        unique (dhi_doc_path, dhi_cmp_id)
) 
tablespace users;


drop synonym dhi;
create synonym dhi for tdoc_dhi_doc_hierarchy;

-- ===================================================================
--
-- Table tdoc_doa_doc_attributes
--
-- Contains the attributes of a document
-- ===================================================================

drop table tdoc_doa_doc_attributes cascade constraints;
create table tdoc_doa_doc_attributes
( 
    doa_cmp_id                    number(9, 0) not null,
    doa_doc_id                    number(9, 0) not null,
    doa_name                      varchar2(128) not null,
    doa_value                     varchar2(3000),
    constraint doa_0_uk
        unique (doa_doc_id, doa_cmp_id, doa_name)
) 
tablespace users;


drop synonym doa;
create synonym doa for tdoc_doa_doc_attributes;

-- ===================================================================
--
-- Table tdoc_dad_docstore_audit
--
-- Contains the audit info for files in the docstore
-- ===================================================================

drop table tdoc_dad_docstore_audit cascade constraints;
create table tdoc_dad_docstore_audit
( 
    dad_cmp_id                    number(9, 0),
    dad_user_id                   number(9, 0),
    dad_doc_path                  varchar2(1000),
    dad_type                      varchar2(128),
    dad_date                      date
) 
tablespace users;


drop synonym dad;
create synonym dad for tdoc_dad_docstore_audit;

-- ===================================================================
--
-- Table tdoc_sta_staging_area
--
-- Staging area info
-- ===================================================================

drop table tdoc_sta_staging_area cascade constraints;
create table tdoc_sta_staging_area
( 
    sta_cmp_id                    number(9, 0) not null,
    sta_id                        number(9, 0),
    sta_name                      varchar2(1000) not null,
    constraint sta_0_pk
        primary key (sta_cmp_id, sta_name)
) 
tablespace users;


drop synonym sta;
create synonym sta for tdoc_sta_staging_area;

drop sequence qdoc_sta_id;
create sequence qdoc_sta_id start with 1 increment by 200 nocache;

drop sequence qdoc_file_id;
create sequence qdoc_file_id start with 1 increment by 1 nocache;


