-- IBM Confidential
-- OCO Source Materials
-- 5724-I68.
-- (C) Copyright IBM Corp. 2000, 2004 - All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure 
-- restricted by GSA ADP Schedule Contract with IBM Corp. 
-- This file is generated by GenSchema!! DO NOT EDIT!!!
-- This file is generated by GenSchema!! DO NOT EDIT!!!


-- ===================================================================
--
-- Table tpgc_pgc_page_customization
--

-- ===================================================================

drop table tpgc_pgc_page_customization cascade constraints;
create table tpgc_pgc_page_customization
( 
    pgc_company_id                number(9, 0),
    pgc_page_id                   number(9, 0),
    pgc_page_name                 varchar2(100)
) 
tablespace users;


drop synonym pgc;
create synonym pgc for tpgc_pgc_page_customization;

drop sequence qpgc_pgc_page_id;
create sequence qpgc_pgc_page_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tpgc_mod_module
--

-- ===================================================================

drop table tpgc_mod_module cascade constraints;
create table tpgc_mod_module
( 
    mod_company_id                number(9, 0),
    mod_module_id                 number(9, 0),
    mod_module_name               varchar2(100),
    mod_width                     char,
    mod_customizable              char,
    mod_class_name                varchar2(100)
) 
tablespace users;


drop synonym mod;
create synonym mod for tpgc_mod_module;

drop sequence qpgc_mod_module_id;
create sequence qpgc_mod_module_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tpgc_pfr_preferences
--
-- The sequence for the primary key for the mod table is always an even number
-- The sequence for the primary key for the pfr table is always an odd number
-- This is to facilitate the distinction between modules and module instances during GUI magic
-- ===================================================================

drop table tpgc_pfr_preferences cascade constraints;
create table tpgc_pfr_preferences
( 
    pfr_company_id                number(9, 0),
    pfr_instance_id               number(9, 0) not null,
    pfr_page_id                   number(9, 0),
    pfr_module_id                 number(9, 0),
    pfr_order                     number(9, 0),
    constraint pfr_0_pk
        primary key (pfr_instance_id)
) 
tablespace users;


drop synonym pfr;
create synonym pfr for tpgc_pfr_preferences;

drop sequence qpgc_pfr_instance_id;
create sequence qpgc_pfr_instance_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tpgc_mxm_maxmin
--
-- This table keeps track of a user's view of a pgc, i.e. whether a module is maximized or minimized.
-- ===================================================================

drop table tpgc_mxm_maxmin cascade constraints;
create table tpgc_mxm_maxmin
( 
    mxm_company_id                number(9, 0),
    mxm_user_id                   number(9, 0),
    mxm_instance_id               number(9, 0),
    mxm_maximized                 number(1, 0)
) 
tablespace users;


drop synonym mxm;
create synonym mxm for tpgc_mxm_maxmin;

-- ===================================================================
--
-- Table tpgc_pmr_params
--

-- ===================================================================

drop table tpgc_pmr_params cascade constraints;
create table tpgc_pmr_params
( 
    pmr_company_id                number(9, 0),
    pmr_instance_id               number(9, 0),
    pmr_display_name              varchar2(100),
    pmr_param_value               varchar2(1000)
) 
tablespace users;


drop synonym pmr;
create synonym pmr for tpgc_pmr_params;

drop sequence qpgc_pgc_page_id;
create sequence qpgc_pgc_page_id start with 1 increment by 1 nocache;
drop sequence qpgc_mod_module_id;
create sequence qpgc_mod_module_id start with 1 increment by 2 nocache;
drop sequence qpgc_pfr_instance_id;
create sequence qpgc_pfr_instance_id start with 2 increment by 2 nocache;


