-- IBM Confidential
-- OCO Source Materials
-- 5724-I68.
-- (C) Copyright IBM Corp. 2000, 2004 - All Rights Reserved.
-- US Government Users Restricted Rights - Use, duplication or disclosure 
-- restricted by GSA ADP Schedule Contract with IBM Corp. 
-- This file is generated by GenSchema!! DO NOT EDIT!!!
-- This file is generated by GenSchema!! DO NOT EDIT!!!


-- ===================================================================
--
-- Table tsch_scj_job
--

-- ===================================================================

drop table tsch_scj_job cascade constraints;
create table tsch_scj_job
( 
    scj_job_id                    number,
    scj_description               varchar2(1000),
    scj_user_id                   number,
    scj_executable                varchar2(100),
    scj_company_id                number,
    scj_recurring                 char
) 
tablespace users;


drop synonym scj;
create synonym scj for tsch_scj_job;

drop sequence qsch_scj_job_id;
create sequence qsch_scj_job_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tsch_scp_params
--
-- special parameter:
-- RUN_ON_SVC=<svc short name>: the job can only run on a given service (scheduler)
-- ===================================================================

drop table tsch_scp_params cascade constraints;
create table tsch_scp_params
( 
    scp_job_id                    number,
    scp_company_id                number,
    scp_param_name                varchar2(100),
    scp_param_value               varchar2(1000)
) 
tablespace users;


drop synonym scp;
create synonym scp for tsch_scp_params;

-- ===================================================================
--
-- Table tsch_ssp_schedule_params
--

-- ===================================================================

drop table tsch_ssp_schedule_params cascade constraints;
create table tsch_ssp_schedule_params
( 
    ssp_schedule_id               number,
    ssp_company_id                number,
    ssp_param_name                varchar2(100),
    ssp_param_value               varchar2(1000)
) 
tablespace users;


drop synonym ssp;
create synonym ssp for tsch_ssp_schedule_params;

-- ===================================================================
--
-- Table tsch_sch_schedule
--

-- ===================================================================

drop table tsch_sch_schedule cascade constraints;
create table tsch_sch_schedule
( 
    sch_schedule_id               number,
    sch_next_running_time         date,
    sch_description               varchar2(1000),
    sch_sch_type                  char,
    sch_job_id                    number,
    sch_time_info                 date,
    sch_company_id                number,
    sch_user_id                   number,
    sch_enabled                   char
) 
tablespace users;


drop synonym sch;
create synonym sch for tsch_sch_schedule;

drop sequence qsch_sch_schedule_id;
create sequence qsch_sch_schedule_id start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tsch_scc_completedschedules
--

-- ===================================================================

drop table tsch_scc_completedschedules cascade constraints;
create table tsch_scc_completedschedules
( 
    scc_schedule_id               number,
    scc_schedule_index            number,
    scc_return_value              varchar2(4000),
    scc_status                    char,
    scc_start_time                date,
    scc_completion_time           date,
    scc_company_id                number,
    scc_user_id                   number
) 
tablespace users;


drop synonym scc;
create synonym scc for tsch_scc_completedschedules;

drop sequence qsch_scc_schedule_index;
create sequence qsch_scc_schedule_index start with 1 increment by 200 nocache;

-- ===================================================================
--
-- Table tsch_scs_schedulestatus
--

-- ===================================================================

drop table tsch_scs_schedulestatus cascade constraints;
create table tsch_scs_schedulestatus
( 
    scs_schedule_id               number,
    scs_percent_done              number,
    scs_user_id                   number,
    scs_company_id                number,
    scs_start_time                date,
    scs_update_time               date
) 
tablespace users;


drop synonym scs;
create synonym scs for tsch_scs_schedulestatus;

-- ===================================================================
--
-- Table tsch_srv_server
--

-- ===================================================================

drop table tsch_srv_server cascade constraints;
create table tsch_srv_server
( 
    srv_port                      number,
    srv_server                    varchar2(100)
) 
tablespace users;


drop synonym srv;
create synonym srv for tsch_srv_server;




